diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 4ccd36f55..6d9e951f4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -5,16 +5,18 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
 import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockModelStandard<T> {
     protected static final DisplayPos FENCE_GUI = new DisplayPos(0, 0, 0, 30, 225 - 90, 0, 0.625f, 0.625f, 0.625f);
     protected static final DisplayPos FENCE_HEAD = new DisplayPos(0, 0, 0, 0, 90, 0, 1f, 1f, 1f);
+
     public BlockModelFenceGate(Block<T> block) {
         super(block);
 
@@ -23,177 +25,159 @@ public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockMod
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBounds();
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBd bounds = new AABBd(this.block.getBounds());
         boolean flag = true;
-        int meta = worldSource.getBlockMetadata(x, y, z);
+        int meta = worldSource.getBlockData(tilePos);
         boolean isOpen = BlockLogicFenceGate.isOpen(meta);
         int direction = BlockLogicFenceGate.getDirection(meta);
-        if(direction == 3 || direction == 1)
-        {
+        if (direction == 3 || direction == 1) {
             float f = 0.4375F;
             float f4 = 0.5625F;
             float f8 = 0.0F;
             float f12 = 0.125F;
-            bounds.set(f, 0.3125F, f8, f4, 1.0F, f12);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            bounds.setMin(f, 0.3125F, f8).setMax(f4, 1.0F, f12);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
             f8 = 0.875F;
             f12 = 1.0F;
-            bounds.set(f, 0.3125F, f8, f4, 1.0F, f12);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        {
+            bounds.setMin(f, 0.3125F, f8).setMax(f4, 1.0F, f12);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else {
             float f1 = 0.0F;
             float f5 = 0.125F;
             float f9 = 0.4375F;
             float f13 = 0.5625F;
-            bounds.set(f1, 0.3125F, f9, f5, 1.0F, f13);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            bounds.setMin(f1, 0.3125F, f9).setMax(f5, 1.0F, f13);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
             f1 = 0.875F;
             f5 = 1.0F;
-            bounds.set(f1, 0.3125F, f9, f5, 1.0F, f13);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            bounds.setMin(f1, 0.3125F, f9).setMax(f5, 1.0F, f13);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
-        if(!isOpen)
-        {
-            if(direction == 3 || direction == 1)
-            {
+        if (!isOpen) {
+            if (direction == 3 || direction == 1) {
                 float f2 = 0.4375F;
                 float f6 = 0.5625F;
                 float f10 = 0.375F;
                 float f14 = 0.5F;
-                bounds.set(f2, 0.375F, f10, f6, 0.9375F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f2, 0.375F, f10).setMax(f6, 0.9375F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f10 = 0.5F;
                 f14 = 0.625F;
-                bounds.set(f2, 0.375F, f10, f6, 0.9375F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f2, 0.375F, f10).setMax(f6, 0.9375F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f10 = 0.625F;
                 f14 = 0.875F;
-                bounds.set(f2, 0.375F, f10, f6, 0.5625F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-                bounds.set(f2, 0.75F, f10, f6, 0.9375F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f2, 0.375F, f10).setMax(f6, 0.5625F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+                bounds.setMin(f2, 0.75F, f10).setMax(f6, 0.9375F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f10 = 0.125F;
                 f14 = 0.375F;
-                bounds.set(f2, 0.375F, f10, f6, 0.5625F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-                bounds.set(f2, 0.75F, f10, f6, 0.9375F, f14);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            } else
-            {
+                bounds.setMin(f2, 0.375F, f10).setMax(f6, 0.5625F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+                bounds.setMin(f2, 0.75F, f10).setMax(f6, 0.9375F, f14);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            } else {
                 float f3 = 0.375F;
                 float f7 = 0.5F;
                 float f11 = 0.4375F;
                 float f15 = 0.5625F;
-                bounds.set(f3, 0.375F, f11, f7, 0.9375F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f3, 0.375F, f11).setMax(f7, 0.9375F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f3 = 0.5F;
                 f7 = 0.625F;
-                bounds.set(f3, 0.375F, f11, f7, 0.9375F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f3, 0.375F, f11).setMax(f7, 0.9375F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f3 = 0.625F;
                 f7 = 0.875F;
-                bounds.set(f3, 0.375F, f11, f7, 0.5625F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-                bounds.set(f3, 0.75F, f11, f7, 0.9375F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f3, 0.375F, f11).setMax(f7, 0.5625F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+                bounds.setMin(f3, 0.75F, f11).setMax(f7, 0.9375F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
                 f3 = 0.125F;
                 f7 = 0.375F;
-                bounds.set(f3, 0.375F, f11, f7, 0.5625F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-                bounds.set(f3, 0.75F, f11, f7, 0.9375F, f15);
-                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+                bounds.setMin(f3, 0.375F, f11).setMax(f7, 0.5625F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+                bounds.setMin(f3, 0.75F, f11).setMax(f7, 0.9375F, f15);
+                renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
             }
-        } else
-        if(direction == 3)
-        {
-            bounds.set(0.8125F, 0.375F, 0.0F, 0.9375F, 0.9375F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.8125F, 0.375F, 0.875F, 0.9375F, 0.9375F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5625F, 0.375F, 0.0F, 0.8125F, 0.5625F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5625F, 0.375F, 0.875F, 0.8125F, 0.5625F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5625F, 0.75F, 0.0F, 0.8125F, 0.9375F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.5625F, 0.75F, 0.875F, 0.8125F, 0.9375F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        if(direction == 1)
-        {
-            bounds.set(0.0625F, 0.375F, 0.0F, 0.1875F, 0.9375F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0625F, 0.375F, 0.875F, 0.1875F, 0.9375F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.1875F, 0.375F, 0.0F, 0.4375F, 0.5625F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.1875F, 0.375F, 0.875F, 0.4375F, 0.5625F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.1875F, 0.75F, 0.0F, 0.4375F, 0.9375F, 0.125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.1875F, 0.75F, 0.875F, 0.4375F, 0.9375F, 1.0F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        if(direction == 0)
-        {
-            bounds.set(0.0F, 0.375F, 0.8125F, 0.125F, 0.9375F, 0.9375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.375F, 0.8125F, 1.0F, 0.9375F, 0.9375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.375F, 0.5625F, 0.125F, 0.5625F, 0.8125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.375F, 0.5625F, 1.0F, 0.5625F, 0.8125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.75F, 0.5625F, 0.125F, 0.9375F, 0.8125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.75F, 0.5625F, 1.0F, 0.9375F, 0.8125F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        } else
-        if(direction == 2)
-        {
-            bounds.set(0.0F, 0.375F, 0.0625F, 0.125F, 0.9375F, 0.1875F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.375F, 0.0625F, 1.0F, 0.9375F, 0.1875F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.375F, 0.1875F, 0.125F, 0.5625F, 0.4375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.375F, 0.1875F, 1.0F, 0.5625F, 0.4375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.0F, 0.75F, 0.1875F, 0.125F, 0.9375F, 0.4375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-            bounds.set(0.875F, 0.75F, 0.1875F, 1.0F, 0.9375F, 0.4375F);
-            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+        } else if (direction == 3) {
+            bounds.setMin(0.8125F, 0.375F, 0.0F).setMax(0.9375F, 0.9375F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.8125F, 0.375F, 0.875F).setMax(0.9375F, 0.9375F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5625F, 0.375F, 0.0F).setMax(0.8125F, 0.5625F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5625F, 0.375F, 0.875F).setMax(0.8125F, 0.5625F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5625F, 0.75F, 0.0F).setMax(0.8125F, 0.9375F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.5625F, 0.75F, 0.875F).setMax(0.8125F, 0.9375F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else if (direction == 1) {
+            bounds.setMin(0.0625F, 0.375F, 0.0F).setMax(0.1875F, 0.9375F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0625F, 0.375F, 0.875F).setMax(0.1875F, 0.9375F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.1875F, 0.375F, 0.0F).setMax(0.4375F, 0.5625F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.1875F, 0.375F, 0.875F).setMax(0.4375F, 0.5625F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.1875F, 0.75F, 0.0F).setMax(0.4375F, 0.9375F, 0.125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.1875F, 0.75F, 0.875F).setMax(0.4375F, 0.9375F, 1.0F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else if (direction == 0) {
+            bounds.setMin(0.0F, 0.375F, 0.8125F).setMax(0.125F, 0.9375F, 0.9375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.375F, 0.8125F).setMax(1.0F, 0.9375F, 0.9375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.375F, 0.5625F).setMax(0.125F, 0.5625F, 0.8125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.375F, 0.5625F).setMax(1.0F, 0.5625F, 0.8125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.75F, 0.5625F).setMax(0.125F, 0.9375F, 0.8125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.75F, 0.5625F).setMax(1.0F, 0.9375F, 0.8125F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        } else if (direction == 2) {
+            bounds.setMin(0.0F, 0.375F, 0.0625F).setMax(0.125F, 0.9375F, 0.1875F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.375F, 0.0625F).setMax(1.0F, 0.9375F, 0.1875F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.375F, 0.1875F).setMax(0.125F, 0.5625F, 0.4375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.375F, 0.1875F).setMax(1.0F, 0.5625F, 0.4375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.0F, 0.75F, 0.1875F).setMax(0.125F, 0.9375F, 0.4375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+            bounds.setMin(0.875F, 0.75F, 0.1875F).setMax(1.0F, 0.9375F, 0.4375F);
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         }
         return flag;
     }
 
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if(renderBlocks.useInventoryTint)
-        {
-            int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            float f1 = (float)(j >> 16 & 0xff) / 255F;
-            float f3 = (float)(j >> 8 & 0xff) / 255F;
-            float f5 = (float)(j & 0xff) / 255F;
+        if (renderBlocks.useInventoryTint) {
+            int j = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            float f1 = (float) (j >> 16 & 0xff) / 255F;
+            float f3 = (float) (j >> 8 & 0xff) / 255F;
+            float f5 = (float) (j & 0xff) / 255F;
             GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
         }
-        for(int k1 = 0; k1 < 3; k1++)
-        {
+        for (int k1 = 0; k1 < 3; k1++) {
             float f6 = 0.0625F;
-            AABB bounds = block.getBounds();
-            if(k1 == 0)
-            {
-                bounds.set(0.5F - f6, 0.3F, 0.0F, 0.5F + f6, 1.0F, f6 * 2.0F);
+            AABBd bounds = new AABBd(this.block.getBounds());
+            if (k1 == 0) {
+                bounds.setMin(0.5F - f6, 0.3F, 0.0F).setMax(0.5F + f6, 1.0F, f6 * 2.0F);
             }
-            if(k1 == 1)
-            {
-                bounds.set(0.5F - f6, 0.3F, 1.0F - f6 * 2.0F, 0.5F + f6, 1.0F, 1.0F);
+            if (k1 == 1) {
+                bounds.setMin(0.5F - f6, 0.3F, 1.0F - f6 * 2.0F).setMax(0.5F + f6, 1.0F, 1.0F);
             }
-            if(k1 == 2)
-            {
-                bounds.set(0.5F - f6, 0.5F, 0.0F, 0.5F + f6, 1.0F - f6, 1.0F);
+            if (k1 == 2) {
+                bounds.setMin(0.5F - f6, 0.5F, 0.0F).setMax(0.5F + f6, 1.0F - f6, 1.0F);
             }
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
index e8b5811dc..268fe9fa5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGatePainted.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFenceGatePainted<T extends BlockLogicFenceGate> extends BlockModelFenceGate<T> {
@@ -12,7 +13,7 @@ public class BlockModelFenceGatePainted<T extends BlockLogicFenceGate> extends B
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
         meta = meta >> 4;
         return BlockModelPlanksPainted.texCoords[meta & 0x0F];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
index d953a6520..ec1faba39 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFencePainted.java
@@ -4,6 +4,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelFencePainted<T extends BlockLogicFence> extends BlockModelFence<T> {
@@ -14,7 +15,7 @@ public class BlockModelFencePainted<T extends BlockLogicFence> extends BlockMode
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
         return BlockModelPlanksPainted.texCoords[meta & 15];
     }
 }
